.386
.model flat,stdcall
option casemap:none

CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
	
   Include \masm32\include\windows2.inc
   include Graphic.imp
   include Graphic.Inc

   
   includelib \masm32\lib\masm32.lib
   includelib \masm32\lib\gdi32.lib
   includelib \masm32\lib\user32.lib
   includelib \masm32\lib\kernel32.lib
   includelib \masm32\lib\winmm.lib
   includelib \masm32\lib\shell32.lib
	includelib	\masm32\lib\ole32.lib
	includelib	\masm32\lib\oleaut32.lib
	includelib \masm32\lib\comdlg32.lib
	includelib \masm32\lib\OpenGL32.lib
	includelib \masm32\lib\GLU32.lib

   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc proto :dword,:DWORD,:DWORD,:DWORD
Draw proto :dword

.data
   ClassName db "GEF",0
   AppName  db "Simple GDI example",0
   
	mDCData dd 0
	mBmpData dd 0
	
				
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	wDC dword ?
	
	mx dword ?
	my dword ?
	
	mclick dword ?
	mclickup dword ?
	
	mouse POINT <?>
	mouse_old POINT <?>
	
	FPSCounter dword ?
	FPS dword ?
	
	bmp1 dword ?
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,\
           0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp


WndProc proc hWnd:dword,uMsg:dword,wParam:dword,lParam:dword
	LOCAL buff[256]:dword
	LOCAL xscr,yscr:dword
	LOCAL r:RECT
	
	.if uMsg==WM_CREATE
		push hWnd
		pop hwnd
		
		invoke GetDC,hWnd
		mov wDC,eax						; Make the DC global so other function can use it
				
		invoke NewThread,offset Draw	; As a change for SetTimer we use a new thread
		
		; Centering the windows on screen
		invoke GetSystemMetrics,SM_CXSCREEN
		mov xscr,eax
		invoke GetSystemMetrics,SM_CYSCREEN
		mov yscr,eax
		invoke GetWindowRect,hWnd,addr r
		mov edx,r.right
		mov eax,r.bottom
		shr xscr,1
		shr yscr,1
		shr edx,1
		shr eax,1
		sub xscr,edx
		sub yscr,eax
		invoke MoveWindow,hWnd,xscr,yscr,r.right,r.bottom,TRUE
		
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	
	ret
WndProc endp

Draw proc uses esi lParam:dword
	LOCAL hDC,mDC,hbmp,mDC2:dword
	LOCAL buff[256]:dword
	LOCAL pbm:dword
	LOCAL dibs:DIBSECTION
	
	invoke CreateCompatibleDC,wDC
	mov mDC,eax
	invoke fCreateDIB,mDC,600,480,32
	mov hbmp,eax				; eax is handle of the bitmap
	mov pbm,edx					; edx is the pointer to the bitmap bits
	invoke SelectObject,mDC,hbmp
	invoke GetObject,hbmp,sizeof DIBSECTION,addr dibs
	
	invoke GetAppPath,addr buff
	invoke lstrcat,addr buff,CADD("Blender_startup.jpg")
	invoke LoadPicture,addr buff
	.if eax!=-1
		mov bmp1,eax
		invoke ShowBitmap,mDC,bmp1
	.else
		invoke MessageBox,hwnd,CADD("Error while loading file"),NULL,MB_OK
	.endif
	
	@@:
	invoke BitBlt,wDC,0,0,dibs.dsBmih.biWidth,dibs.dsBmih.biHeight,mDC,0,0,SRCCOPY
	invoke Sleep,100
	jmp @b
	
	ret
Draw endp

end start